View Issue Details

IDProjectCategoryView StatusLast Update
0005806libmicrohttpdbuild systempublic2019-10-26 19:41
ReporterTuxHandwerkerAssigned ToChristian Grothoff 
PrioritynormalSeveritymajorReproducibilityalways
Status closedResolutionfixed 
Platformx86_64OSCentOSOS Version7.6
Product Version0.9.65 
Target Version0.9.67Fixed in Version0.9.67 
Summary0005806: 0.9.65 build fails with gnutls
DescriptionThe build fails with:
Making install in microhttpd
make[2]: Entering directory `/builddir/build/BUILD/gvm-helper-0.0.1/libmicrohttpd-0.9.65/src/microhttpd'
/bin/sh ../../libtool --tag=CC --mode=compile gcc -DHAVE_CONFIG_H -I. -I../.. -I../../src/include -I../../src/microhttpd -I/usr/include/p11-kit-1 -DBUILDING_MHD_LIB=1 -fvisibility=hidden -pthread -I/usr/include/p11-kit-1 -I/builddir/build/BUILD/gvm-helper-0.0.1/libassuan-2.5.3/src -I/builddir/build/BUILD/gvm-helper-0.0.1/libgpg-error-1.36/src -O2 -g -pipe -Wall -Wp,-D_FORTIFY_SOURCE=2 -fexceptions -fstack-protector-strong --param=ssp-buffer-size=4 -grecord-gcc-switches -specs=/usr/lib/rpm/redhat/redhat-hardened-cc1 -m64 -mtune=generic -fno-strict-aliasing -c -o libmicrohttpd_la-connection.lo `test -f 'connection.c' || echo './'`connection.c
libtool: compile: gcc -DHAVE_CONFIG_H -I. -I../.. -I../../src/include -I../../src/microhttpd -I/usr/include/p11-kit-1 -DBUILDING_MHD_LIB=1 -fvisibility=hidden -pthread -I/usr/include/p11-kit-1 -I/builddir/build/BUILD/gvm-helper-0.0.1/libassuan-2.5.3/src -I/builddir/build/BUILD/gvm-helper-0.0.1/libgpg-error-1.36/src -O2 -g -pipe -Wall -Wp,-D_FORTIFY_SOURCE=2 -fexceptions -fstack-protector-strong --param=ssp-buffer-size=4 -grecord-gcc-switches -specs=/usr/lib/rpm/redhat/redhat-hardened-cc1 -m64 -mtune=generic -fno-strict-aliasing -c connection.c -fPIC -DPIC -o .libs/libmicrohttpd_la-connection.o
/bin/sh ../../libtool --tag=CC --mode=compile gcc -DHAVE_CONFIG_H -I. -I../.. -I../../src/include -I../../src/microhttpd -I/usr/include/p11-kit-1 -DBUILDING_MHD_LIB=1 -fvisibility=hidden -pthread -I/usr/include/p11-kit-1 -I/builddir/build/BUILD/gvm-helper-0.0.1/libassuan-2.5.3/src -I/builddir/build/BUILD/gvm-helper-0.0.1/libgpg-error-1.36/src -O2 -g -pipe -Wall -Wp,-D_FORTIFY_SOURCE=2 -fexceptions -fstack-protector-strong --param=ssp-buffer-size=4 -grecord-gcc-switches -specs=/usr/lib/rpm/redhat/redhat-hardened-cc1 -m64 -mtune=generic -fno-strict-aliasing -c -o libmicrohttpd_la-reason_phrase.lo `test -f 'reason_phrase.c' || echo './'`reason_phrase.c
libtool: compile: gcc -DHAVE_CONFIG_H -I. -I../.. -I../../src/include -I../../src/microhttpd -I/usr/include/p11-kit-1 -DBUILDING_MHD_LIB=1 -fvisibility=hidden -pthread -I/usr/include/p11-kit-1 -I/builddir/build/BUILD/gvm-helper-0.0.1/libassuan-2.5.3/src -I/builddir/build/BUILD/gvm-helper-0.0.1/libgpg-error-1.36/src -O2 -g -pipe -Wall -Wp,-D_FORTIFY_SOURCE=2 -fexceptions -fstack-protector-strong --param=ssp-buffer-size=4 -grecord-gcc-switches -specs=/usr/lib/rpm/redhat/redhat-hardened-cc1 -m64 -mtune=generic -fno-strict-aliasing -c reason_phrase.c -fPIC -DPIC -o .libs/libmicrohttpd_la-reason_phrase.o
/bin/sh ../../libtool --tag=CC --mode=compile gcc -DHAVE_CONFIG_H -I. -I../.. -I../../src/include -I../../src/microhttpd -I/usr/include/p11-kit-1 -DBUILDING_MHD_LIB=1 -fvisibility=hidden -pthread -I/usr/include/p11-kit-1 -I/builddir/build/BUILD/gvm-helper-0.0.1/libassuan-2.5.3/src -I/builddir/build/BUILD/gvm-helper-0.0.1/libgpg-error-1.36/src -O2 -g -pipe -Wall -Wp,-D_FORTIFY_SOURCE=2 -fexceptions -fstack-protector-strong --param=ssp-buffer-size=4 -grecord-gcc-switches -specs=/usr/lib/rpm/redhat/redhat-hardened-cc1 -m64 -mtune=generic -fno-strict-aliasing -c -o libmicrohttpd_la-daemon.lo `test -f 'daemon.c' || echo './'`daemon.c
libtool: compile: gcc -DHAVE_CONFIG_H -I. -I../.. -I../../src/include -I../../src/microhttpd -I/usr/include/p11-kit-1 -DBUILDING_MHD_LIB=1 -fvisibility=hidden -pthread -I/usr/include/p11-kit-1 -I/builddir/build/BUILD/gvm-helper-0.0.1/libassuan-2.5.3/src -I/builddir/build/BUILD/gvm-helper-0.0.1/libgpg-error-1.36/src -O2 -g -pipe -Wall -Wp,-D_FORTIFY_SOURCE=2 -fexceptions -fstack-protector-strong --param=ssp-buffer-size=4 -grecord-gcc-switches -specs=/usr/lib/rpm/redhat/redhat-hardened-cc1 -m64 -mtune=generic -fno-strict-aliasing -c daemon.c -fPIC -DPIC -o .libs/libmicrohttpd_la-daemon.o
daemon.c: In function 'internal_add_connection':
daemon.c:2527:7: error: unknown type name 'gnutls_init_flags_t'
       gnutls_init_flags_t flags;
       ^
Additional Information0.9.63 will build fine.
CentOS comes with gnutls version 3.3.29-9
TagsNo tags attached.

Activities

Christian Grothoff

2019-07-29 17:53

manager   ~0014755

Very strange, the C code seems fine (and unchanged!), so likely something related to the build system. Providing config.log may help, as could git bisecting this. I don't have a CentOS at hand myself.

AndreasStieger

2019-08-02 13:43

reporter   ~0014767

Not strange at all. gnutls_init_flags_t was introduced in GnuTLS 3.5.0:
https://github.com/gnutls/gnutls/commit/f07542836648a3149880505a45b099aef74a8b02
https://github.com/gnutls/gnutls/compare/gnutls_3_4_11...gnutls_3_5_0#diff-cd71deb19a583f81358de42c2768a1e4L318-R375
A change in libmicrohttpd >= 0.9.64 introduced this dependency:
https://git.gnunet.org/libmicrohttpd.git/commit/?id=1917b866996413f09fa88ae0a6169cb9bd7079e8

Christian Grothoff

2019-08-02 15:46

manager   ~0014768

I see. I've pushed a likely fix to Git master, could you confirm that this fixes it?

AndreasStieger

2019-08-02 16:02

reporter   ~0014769

[[https://git.gnunet.org/libmicrohttpd.git/commit/?id=b84ee1fa41c53c43aa7ed1583c36af5cb7c77a0f|b84ee1f]] fixes this issue with 3.3.27 and others.

TuxHandwerker

2019-08-13 09:16

reporter   ~0014780

Yes,
https://git.gnunet.org/libmicrohttpd.git/patch/?id=b84ee1fa41c53c43aa7ed1583c36af5cb7c77a0f
will fix it.

Thanks

Issue History

Date Modified Username Field Change
2019-07-18 10:04 TuxHandwerker New Issue
2019-07-29 17:53 Christian Grothoff Note Added: 0014755
2019-07-29 17:53 Christian Grothoff Assigned To => Christian Grothoff
2019-07-29 17:53 Christian Grothoff Status new => feedback
2019-08-02 13:43 AndreasStieger Note Added: 0014767
2019-08-02 15:46 Christian Grothoff Note Added: 0014768
2019-08-02 15:46 Christian Grothoff Product Version => 0.9.65
2019-08-02 15:46 Christian Grothoff Target Version => 0.9.67
2019-08-02 16:02 AndreasStieger Note Added: 0014769
2019-08-13 09:16 TuxHandwerker Note Added: 0014780
2019-08-13 09:16 TuxHandwerker Status feedback => assigned
2019-08-13 10:12 Christian Grothoff Status assigned => resolved
2019-08-13 10:12 Christian Grothoff Resolution open => fixed
2019-08-13 10:12 Christian Grothoff Fixed in Version => 0.9.67
2019-10-26 19:41 Christian Grothoff Status resolved => closed